#include "avl_structures.h"

#ifndef _h_zcl_gloomlib_avl_functions

	#define _avl_mode_insertion	0
	#define _avl_mode_removal	1

	extern avl_node_t *avl_rebalance_tree(avl_node_t *node, uint8_t mode);
	extern avl_node_t *avl_rotate_tree(avl_node_t *subtree, uint8_t direction);

	extern avl_node_t *avl_initialize(avl_node_t *node, uint32_t key);

	extern avl_node_t *avl_insert(avl_node_t **tree, avl_node_t *node);
	extern avl_node_t *avl_remove(avl_node_t **tree, avl_node_t *node);
	extern avl_node_t *avl_locate(avl_node_t **tree, unsigned int key);

	extern void avl_upbalance(avl_node_t **tree, avl_node_t *node, uint8_t stdir);

	#ifdef __zcl_gloomlib_debug__
		extern void avl_showtree(avl_node_t **tree, avl_node_t *node);
	#endif

#endif
