#include "avl_functions.h"

	avl_node_t *avl_insert(avl_node_t **tree, avl_node_t *node) {
		if((!tree) || (!node)) return (avl_node_t*)_ret_failure;
		else if(!*tree) *tree = node;
		else {
			avl_node_t *iterator = *tree, *shadow = iterator;
			unsigned int path = 0;

			while(1) {
				path = (node->key > iterator->key);
				if(iterator->key == node->key) {
					return node;
				} else if(iterator->paths[path]) {
					shadow = iterator;
					iterator = iterator->paths[path];
				} else {
					iterator->paths[path] = node;
					node->paths[_avl_nodelink_parent] = iterator;
					shadow = iterator;
					iterator = node;
					break;
				}
			}

			while(shadow) {
				path = (iterator->key > shadow->key);
				shadow->balance += (path ? 1 : -1);

				if(shadow->balance == _avl_balance_b) break;
				else if((shadow->balance == _avl_balance_lc) || (shadow->balance == _avl_balance_rc)) {
					if(!shadow->paths[_avl_nodelink_parent]) *tree = \
						avl_rebalance_tree(shadow, _avl_mode_insertion);
					else {
						path = (shadow->key > shadow->paths[_avl_nodelink_parent]->key);
						shadow->paths[_avl_nodelink_parent]->paths[path] = \
							avl_rebalance_tree(shadow, _avl_mode_insertion);
					}
					break;
				}

				shadow = shadow->paths[_avl_nodelink_parent];
				iterator = iterator->paths[_avl_nodelink_parent];
			}
		}
		return node;
	}
