#include "avl_functions.h"

	avl_node_t *avl_rebalance_tree(avl_node_t *node, uint8_t mode) {
		avl_node_t *x_node = node->paths[(node->balance ? _avl_nodelink_right : _avl_nodelink_left)];
		avl_node_t *z_node = x_node->paths[(node->balance ? _avl_nodelink_left : _avl_nodelink_right)];

		uint32_t bal_buff = node->balance;

		if(x_node->balance == (bal_buff ? _avl_balance_lh : _avl_balance_rh)) {
			if(z_node->balance == (bal_buff ? _avl_balance_rh : _avl_balance_lh)) {
				x_node->balance = z_node->balance = _avl_balance_b;
				node->balance = (bal_buff ? _avl_balance_lh : _avl_balance_rh);
			} else if(z_node->balance == (bal_buff ? _avl_balance_lh : _avl_balance_rh)) {
				x_node->balance = (bal_buff ? _avl_balance_rh : _avl_balance_lh);
				node->balance = z_node->balance = _avl_balance_b;
			} else node->balance = x_node->balance = z_node->balance = _avl_balance_b;
			node->paths[(bal_buff ? _avl_nodelink_right : _avl_nodelink_left)] = \
				avl_rotate_tree(x_node, (bal_buff ? _avl_nodelink_right : _avl_nodelink_left));
		} else {
			if((mode == _avl_mode_removal) && (x_node->balance == _avl_balance_b)) {
				node->balance = (bal_buff ? _avl_balance_rh : _avl_balance_lh);
				x_node->balance = (bal_buff ? _avl_balance_lh : _avl_balance_rh);
			} else node->balance = x_node->balance = _avl_balance_b;
		}

		return avl_rotate_tree(node, (bal_buff ? _avl_nodelink_left : _avl_nodelink_right));
	}
