#include "avl_functions.h"

	avl_node_t *avl_remove(avl_node_t **tree, avl_node_t *node) {
		if((!tree) || (!*tree) || (!node)) return (avl_node_t*)_ret_failure;
		else {
			unsigned int path = node->key;
			avl_node_t *ancestor = node->paths[_avl_nodelink_parent];
			avl_node_t *ret_node = 0x00000000;
		
			if((node->paths[_avl_nodelink_left]) && (node->paths[_avl_nodelink_right])) {
				avl_node_t *replacement = node->paths[_avl_nodelink_left];

				while(replacement->paths[_avl_nodelink_right]) replacement = replacement->paths[_avl_nodelink_right];

				if(replacement->paths[_avl_nodelink_left]) {
					path = replacement->key;
					replacement->key = replacement->paths[_avl_nodelink_left]->key;
			
					ret_node = replacement->paths[_avl_nodelink_left];
					//free(replacement->paths[_avl_nodelink_left]);

					replacement->paths[_avl_nodelink_left] = 0;
					replacement->balance = _avl_balance_b;
					node->key = path;
					path = (replacement->key > replacement->paths[_avl_nodelink_parent]->key);
					replacement = replacement->paths[_avl_nodelink_parent];
				} else {
					path = (replacement->key > replacement->paths[_avl_nodelink_parent]->key);
					node->key = replacement->key;
					replacement = replacement->paths[_avl_nodelink_parent];

					ret_node = replacement->paths[path];
					//free(replacement->paths[path]);

					replacement->paths[path] = 0;
				}
				avl_upbalance(tree, replacement, path);
				return ret_node;	
			} else if((!node->paths[_avl_nodelink_left]) && (!node->paths[_avl_nodelink_right])) {
				ret_node = node;
				//free(node);
				if(*tree == node) {
					*tree = 0;
					return ret_node;
				}
				path = (path > ancestor->key);
				ancestor->paths[path] = 0;
			} else {
				if(*tree == node) {
					*tree = node->paths[((node->balance-1) ? 1 : 0)]; 
					return node;	
				} else {
					path = (path > ancestor->key);
					ancestor->paths[path] = node->paths[((node->balance-1) ? 1 : 0)];
					ancestor->paths[path]->paths[_avl_nodelink_parent] = ancestor;
				}
				ret_node = node;
				//free(node);
			}
			avl_upbalance(tree, ancestor, path);
			return ret_node;
		}
	}
